package org.mortbay.ijetty.util;

import android.content.Context;
import android.content.SharedPreferences;


public class UpdatePreferenceUtils {

    private static final String PREF_UPDATE_NEEDED = "update_needed";
    private static final String CURRENT_VERSION = "version_updated";

    private SharedPreferences mPreferences;

    UpdatePreferenceUtils(SharedPreferences preferences) {
        mPreferences = preferences;
    }

    public static UpdatePreferenceUtils create(Context context) {
        return new UpdatePreferenceUtils(context.getSharedPreferences(PREF_UPDATE_NEEDED, Context.MODE_PRIVATE));
    }

    public boolean isUpdateNeeded(String currentVersion) {
        return !currentVersion.equals(mPreferences.getString(CURRENT_VERSION, ""));
    }

    public void setCurrentVersion(String currentVersion) {
        mPreferences.edit().putString(CURRENT_VERSION, currentVersion).apply();
    }
}
