/*
 * Copyright 2012 Steffen Trumtrar <s.trumtrar@pengutronix.de>
 *
 * Applied additional changes to support Maxwell_10 board
 * Copyright (C) 2015-16 Gigaset Communications GmbH All Rights Reserved.
 *
 * description of key_cfgs
 *
 * This file is released under the GPLv2
 */

#ifndef __LINUX_TOUCH_KEY_CFG_H
#define __LINUX_TOUCH_KEY_CFG_H

#include <linux/types.h>

// use only type int for this struct!
struct key_cfg {
	int x;
	int y;
	int key_code;
};

struct touch_key_cfg {
	struct key_cfg *akey_cfg;
	int key_mask;
	int key_cnt;
};

/*
 * This describes all touch_key_cfgs settings.
 * The native_cfg is the default setting for this touch_key_cfg.
 * Drivers that can handle multiple touch_key_cfg should work with this struct and
 * convert each entry to the desired end result.
 */
struct touch_key_cfgs {
	unsigned int num_key_cfgs;
	unsigned int native_cfg;
	struct touch_key_cfg **atouch_key_cfg;
};

/* get one entry from struct touch_key_cfgs */
static inline struct touch_key_cfg *touch_key_cfgs_get(const struct
							 touch_key_cfgs *tkcs,
							 unsigned int index)
{
	if (tkcs->num_key_cfgs > index)
		return tkcs->atouch_key_cfg[index];
	else
		return NULL;
}

#endif
