#
# Copyright (C) 2008 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# We have a special case here where we build the library's resources
# independently from its code, so we need to find where the resource
# class source got placed in the course of building the resources.
# Thus, the magic here.
# Also, this module cannot depend directly on the R.java file; if it
# did, the PRIVATE_* vars for R.java wouldn't be guaranteed to be correct.
# Instead, it depends on the R.stamp file, which lists the corresponding
# R.java file as a prerequisite.
# TODO: find a more appropriate way to do this.

# ****************** Copyright (c) 2014 by Gigaset Communications GmbH ******
# Filename : Android.mk
# Owner    : [STC]
#-------------------------------------------------------------------------
# Function : 
# Special cases : 
# Defintion : Compile MaxwellAccount 
#-------------------------------------------------------------------------
# 20-08-2013, Gigaset Communications GmbH
#*************************************************************************
LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)
LOCAL_MODULE := libYModem
LOCAL_MODULE_TAGS := optional
LOCAL_SRC_FILES := ../comms/ymodem_tx.cpp \
				   ../comms/ymodem_rx.cpp \
				   ../comms/ymodem.cpp \
				   ../comms/serial_port.cpp \
				   ../comms/dvf99_upgrade.cpp \
				   ../comms/Dvf99UpgradeWrapper.cpp \
						
				   

LOCAL_SHARED_LIBRARIES += libcutils libbinder liblog libc libdl libutils
LOCAL_C_INCLUDES += ../comms/
LOCAL_LDLIBS := -llog

include $(BUILD_SHARED_LIBRARY)
